/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/DenseLaserObjectFeatures.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_DENSELASEROBJECTFEATURES_H
#define CALIBRATION_MSGS_DENSELASEROBJECTFEATURES_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "calibration_msgs/DenseLaserPoint.h"
#include "geometry_msgs/Point.h"

namespace calibration_msgs
{

//! \htmlinclude DenseLaserObjectFeatures.msg.html

class DenseLaserObjectFeatures : public ros::Message
{
public:
  typedef boost::shared_ptr<DenseLaserObjectFeatures> Ptr;
  typedef boost::shared_ptr<DenseLaserObjectFeatures const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<calibration_msgs::DenseLaserPoint> _dense_laser_points_type;
  typedef std::vector<geometry_msgs::Point> _object_points_type;
  typedef uint8_t _success_type;

  roslib::Header header;
  std::vector<calibration_msgs::DenseLaserPoint> dense_laser_points;
  std::vector<geometry_msgs::Point> object_points;
  uint8_t success;

  DenseLaserObjectFeatures() : ros::Message(),
    success(0)
  {
  }
  DenseLaserObjectFeatures(const DenseLaserObjectFeatures &copy) : ros::Message(),
    header(copy.header),
    success(copy.success)
  {
    (void)copy;
    dense_laser_points = copy.dense_laser_points;
    object_points = copy.object_points;
  }
  DenseLaserObjectFeatures &operator =(const DenseLaserObjectFeatures &copy)
  {
    if (this == &copy)
      return *this;
    dense_laser_points.clear();
    object_points.clear();
    header = copy.header;
    dense_laser_points = copy.dense_laser_points;
    object_points = copy.object_points;
    success = copy.success;
    return *this;
  }
  virtual ~DenseLaserObjectFeatures() 
  {
    dense_laser_points.clear();
    object_points.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/DenseLaserObjectFeatures"); }
  inline static std::string __s_getMD5Sum() { return std::string("b642d46e47d54e00f98a3d98b02b5cc6"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Synchronized with sensor output\n"
    "Header header\n"
    "\n"
    "# Pixel locations of detected features\n"
    "DenseLaserPoint[] dense_laser_points\n"
    "\n"
    "# Defines geometry of detected features in some \"object\" coordinate frame\n"
    "geometry_msgs/Point[] object_points\n"
    "\n"
    "# False on detection failure or partial detection\n"
    "uint8 success\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: calibration_msgs/DenseLaserPoint\n"
    "# Stores the xy subpixel location of a point in a DenseLaserSnapshot\n"
    "float64 scan  # Which scan line we detected the feature\n"
    "float64 ray   # Which ray in the specified scan we detected the feature\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_dense_laser_points_size(uint32_t __ros_new_size)
  {
    this->dense_laser_points.resize(__ros_new_size);
  }
  inline uint32_t get_dense_laser_points_size() const { return dense_laser_points.size(); }
  inline void get_dense_laser_points_vec (std::vector<calibration_msgs::DenseLaserPoint> &__ros_vec) const
  {
    __ros_vec = this->dense_laser_points;
  }
  inline void set_dense_laser_points_vec(const std::vector<calibration_msgs::DenseLaserPoint> &__ros_vec)
  {
    this->dense_laser_points = __ros_vec;
  }
  void set_object_points_size(uint32_t __ros_new_size)
  {
    this->object_points.resize(__ros_new_size);
  }
  inline uint32_t get_object_points_size() const { return object_points.size(); }
  inline void get_object_points_vec (std::vector<geometry_msgs::Point> &__ros_vec) const
  {
    __ros_vec = this->object_points;
  }
  inline void set_object_points_vec(const std::vector<geometry_msgs::Point> &__ros_vec)
  {
    this->object_points = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (dense_laser_points.size() ? dense_laser_points.size() * dense_laser_points[0].serializationLength() : 0); // dense_laser_points
    __l += 4 + (object_points.size() ? object_points.size() * object_points[0].serializationLength() : 0); // object_points
    __l += 1; // success
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __dense_laser_points_size = dense_laser_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __dense_laser_points_size);
    for (size_t i = 0; i < __dense_laser_points_size; i++)
      write_ptr = dense_laser_points[i].serialize(write_ptr, seq);
    uint32_t __object_points_size = object_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __object_points_size);
    for (size_t i = 0; i < __object_points_size; i++)
      write_ptr = object_points[i].serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, success);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __dense_laser_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __dense_laser_points_size);
    set_dense_laser_points_size(__dense_laser_points_size);
    for (size_t i = 0; i < __dense_laser_points_size; i++)
      read_ptr = dense_laser_points[i].deserialize(read_ptr);
    uint32_t __object_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __object_points_size);
    set_object_points_size(__object_points_size);
    for (size_t i = 0; i < __object_points_size; i++)
      read_ptr = object_points[i].deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, success);
    return read_ptr;
  }
};

typedef boost::shared_ptr<DenseLaserObjectFeatures> DenseLaserObjectFeaturesPtr;
typedef boost::shared_ptr<DenseLaserObjectFeatures const> DenseLaserObjectFeaturesConstPtr;


}

#endif
