/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/DenseLaserSnapshot.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_DENSELASERSNAPSHOT_H
#define CALIBRATION_MSGS_DENSELASERSNAPSHOT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"

namespace calibration_msgs
{

//! \htmlinclude DenseLaserSnapshot.msg.html

class DenseLaserSnapshot : public ros::Message
{
public:
  typedef boost::shared_ptr<DenseLaserSnapshot> Ptr;
  typedef boost::shared_ptr<DenseLaserSnapshot const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef float _angle_min_type;
  typedef float _angle_max_type;
  typedef float _angle_increment_type;
  typedef float _time_increment_type;
  typedef float _range_min_type;
  typedef float _range_max_type;
  typedef uint32_t _readings_per_scan_type;
  typedef uint32_t _num_scans_type;
  typedef std::vector<float> _ranges_type;
  typedef std::vector<float> _intensities_type;
  typedef std::vector<ros::Time> _scan_start_type;

  roslib::Header header;
  float angle_min;
  float angle_max;
  float angle_increment;
  float time_increment;
  float range_min;
  float range_max;
  uint32_t readings_per_scan;
  uint32_t num_scans;
  std::vector<float> ranges;
  std::vector<float> intensities;
  std::vector<ros::Time> scan_start;

  DenseLaserSnapshot() : ros::Message(),
    angle_min(0),
    angle_max(0),
    angle_increment(0),
    time_increment(0),
    range_min(0),
    range_max(0),
    readings_per_scan(0),
    num_scans(0)
  {
  }
  DenseLaserSnapshot(const DenseLaserSnapshot &copy) : ros::Message(),
    header(copy.header),
    angle_min(copy.angle_min),
    angle_max(copy.angle_max),
    angle_increment(copy.angle_increment),
    time_increment(copy.time_increment),
    range_min(copy.range_min),
    range_max(copy.range_max),
    readings_per_scan(copy.readings_per_scan),
    num_scans(copy.num_scans)
  {
    (void)copy;
    ranges = copy.ranges;
    intensities = copy.intensities;
    scan_start = copy.scan_start;
  }
  DenseLaserSnapshot &operator =(const DenseLaserSnapshot &copy)
  {
    if (this == &copy)
      return *this;
    ranges.clear();
    intensities.clear();
    scan_start.clear();
    header = copy.header;
    angle_min = copy.angle_min;
    angle_max = copy.angle_max;
    angle_increment = copy.angle_increment;
    time_increment = copy.time_increment;
    range_min = copy.range_min;
    range_max = copy.range_max;
    readings_per_scan = copy.readings_per_scan;
    num_scans = copy.num_scans;
    ranges = copy.ranges;
    intensities = copy.intensities;
    scan_start = copy.scan_start;
    return *this;
  }
  virtual ~DenseLaserSnapshot() 
  {
    ranges.clear();
    intensities.clear();
    scan_start.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/DenseLaserSnapshot"); }
  inline static std::string __s_getMD5Sum() { return std::string("deb2810d3530db3484f886a81243195d"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Provides all the state & sensor information for\n"
    "# a single sweep of laser attached to some mechanism.\n"
    "# Most likely, this will be used with PR2's tilting laser mechanism\n"
    "Header header\n"
    "\n"
    "# Store the laser intrinsics. This is very similar to the\n"
    "# intrinsics commonly stored in \n"
    "float32 angle_min        # start angle of the scan [rad]\n"
    "float32 angle_max        # end angle of the scan [rad]\n"
    "float32 angle_increment  # angular distance between measurements [rad]\n"
    "float32 time_increment   # time between measurements [seconds]\n"
    "float32 range_min        # minimum range value [m]\n"
    "float32 range_max        # maximum range value [m]\n"
    "\n"
    "# Define the size of the binary data\n"
    "uint32 readings_per_scan    # (Width)\n"
    "uint32 num_scans            # (Height)\n"
    "\n"
    "# 2D Arrays storing laser data.\n"
    "# We can think of each type data as being a single channel image.\n"
    "# Each row of the image has data from a single scan, and scans are\n"
    "# concatenated to form the entire 'image'.\n"
    "float32[] ranges            # (Image data)\n"
    "float32[] intensities       # (Image data)\n"
    "\n"
    "# Store the start time of each scan\n"
    "time[] scan_start\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_ranges_size(uint32_t __ros_new_size)
  {
    this->ranges.resize(__ros_new_size);
  }
  inline uint32_t get_ranges_size() const { return ranges.size(); }
  inline void get_ranges_vec (std::vector<float> &__ros_vec) const
  {
    __ros_vec = this->ranges;
  }
  inline void set_ranges_vec(const std::vector<float> &__ros_vec)
  {
    this->ranges = __ros_vec;
  }
  void set_intensities_size(uint32_t __ros_new_size)
  {
    this->intensities.resize(__ros_new_size);
  }
  inline uint32_t get_intensities_size() const { return intensities.size(); }
  inline void get_intensities_vec (std::vector<float> &__ros_vec) const
  {
    __ros_vec = this->intensities;
  }
  inline void set_intensities_vec(const std::vector<float> &__ros_vec)
  {
    this->intensities = __ros_vec;
  }
  void set_scan_start_size(uint32_t __ros_new_size)
  {
    this->scan_start.resize(__ros_new_size);
  }
  inline uint32_t get_scan_start_size() const { return scan_start.size(); }
  inline void get_scan_start_vec (std::vector<ros::Time> &__ros_vec) const
  {
    __ros_vec = this->scan_start;
  }
  inline void set_scan_start_vec(const std::vector<ros::Time> &__ros_vec)
  {
    this->scan_start = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4; // angle_min
    __l += 4; // angle_max
    __l += 4; // angle_increment
    __l += 4; // time_increment
    __l += 4; // range_min
    __l += 4; // range_max
    __l += 4; // readings_per_scan
    __l += 4; // num_scans
    __l += 4 + (ranges.size() ? ranges.size() * 4 : 0); // ranges
    __l += 4 + (intensities.size() ? intensities.size() * 4 : 0); // intensities
    __l += 4 + (scan_start.size() ? scan_start.size() * 8 : 0); // scan_start
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_min);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_max);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, angle_increment);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, time_increment);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, range_min);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, range_max);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, readings_per_scan);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, num_scans);
    uint32_t __ranges_size = ranges.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ranges_size);
    memcpy(write_ptr, &ranges[0], sizeof(float) * __ranges_size);
    write_ptr += sizeof(float) * __ranges_size;
    uint32_t __intensities_size = intensities.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __intensities_size);
    memcpy(write_ptr, &intensities[0], sizeof(float) * __intensities_size);
    write_ptr += sizeof(float) * __intensities_size;
    uint32_t __scan_start_size = scan_start.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __scan_start_size);
    for (size_t i = 0; i < __scan_start_size; i++)
    {
      SROS_SERIALIZE_PRIMITIVE(write_ptr, scan_start[i].sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, scan_start[i].nsec);
    }
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_min);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_max);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, angle_increment);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, time_increment);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, range_min);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, range_max);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, readings_per_scan);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, num_scans);
    uint32_t __ranges_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ranges_size);
    set_ranges_size(__ranges_size);
    memcpy(&ranges[0], read_ptr, sizeof(float) * __ranges_size);
    read_ptr += sizeof(float) * __ranges_size;
    uint32_t __intensities_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __intensities_size);
    set_intensities_size(__intensities_size);
    memcpy(&intensities[0], read_ptr, sizeof(float) * __intensities_size);
    read_ptr += sizeof(float) * __intensities_size;
    uint32_t __scan_start_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __scan_start_size);
    set_scan_start_size(__scan_start_size);
    for (size_t i = 0; i < __scan_start_size; i++)
    {
      SROS_DESERIALIZE_PRIMITIVE(read_ptr, scan_start[i].sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, scan_start[i].nsec);
    }
    return read_ptr;
  }
};

typedef boost::shared_ptr<DenseLaserSnapshot> DenseLaserSnapshotPtr;
typedef boost::shared_ptr<DenseLaserSnapshot const> DenseLaserSnapshotConstPtr;


}

#endif
