/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/calibration_msgs/msg/JointStateCalibrationPattern.msg.  Do not edit! */
#ifndef CALIBRATION_MSGS_JOINTSTATECALIBRATIONPATTERN_H
#define CALIBRATION_MSGS_JOINTSTATECALIBRATIONPATTERN_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point32.h"
#include "sensor_msgs/JointState.h"

namespace calibration_msgs
{

//! \htmlinclude JointStateCalibrationPattern.msg.html

class JointStateCalibrationPattern : public ros::Message
{
public:
  typedef boost::shared_ptr<JointStateCalibrationPattern> Ptr;
  typedef boost::shared_ptr<JointStateCalibrationPattern const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<geometry_msgs::Point32> _object_points_type;
  typedef std::vector<sensor_msgs::JointState> _joint_points_type;

  roslib::Header header;
  std::vector<geometry_msgs::Point32> object_points;
  std::vector<sensor_msgs::JointState> joint_points;

  JointStateCalibrationPattern() : ros::Message()
  {
  }
  JointStateCalibrationPattern(const JointStateCalibrationPattern &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    object_points = copy.object_points;
    joint_points = copy.joint_points;
  }
  JointStateCalibrationPattern &operator =(const JointStateCalibrationPattern &copy)
  {
    if (this == &copy)
      return *this;
    object_points.clear();
    joint_points.clear();
    header = copy.header;
    object_points = copy.object_points;
    joint_points = copy.joint_points;
    return *this;
  }
  virtual ~JointStateCalibrationPattern() 
  {
    object_points.clear();
    joint_points.clear();
  }
  inline static std::string __s_getDataType() { return std::string("calibration_msgs/JointStateCalibrationPattern"); }
  inline static std::string __s_getMD5Sum() { return std::string("2a9763ecd4115aab77fac06c99ae1fb7"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "Header header\n"
    "geometry_msgs/Point32[]  object_points\n"
    "sensor_msgs/JointState[] joint_points\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_object_points_size(uint32_t __ros_new_size)
  {
    this->object_points.resize(__ros_new_size);
  }
  inline uint32_t get_object_points_size() const { return object_points.size(); }
  inline void get_object_points_vec (std::vector<geometry_msgs::Point32> &__ros_vec) const
  {
    __ros_vec = this->object_points;
  }
  inline void set_object_points_vec(const std::vector<geometry_msgs::Point32> &__ros_vec)
  {
    this->object_points = __ros_vec;
  }
  void set_joint_points_size(uint32_t __ros_new_size)
  {
    this->joint_points.resize(__ros_new_size);
  }
  inline uint32_t get_joint_points_size() const { return joint_points.size(); }
  uint32_t calc_joint_points_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_points_size = joint_points.size();
    for (size_t i = 0; i < joint_points_size; i++)
      l += joint_points[i].serializationLength();
    return l;
  }
  inline void get_joint_points_vec (std::vector<sensor_msgs::JointState> &__ros_vec) const
  {
    __ros_vec = this->joint_points;
  }
  inline void set_joint_points_vec(const std::vector<sensor_msgs::JointState> &__ros_vec)
  {
    this->joint_points = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (object_points.size() ? object_points.size() * object_points[0].serializationLength() : 0); // object_points
    __l += 4 + calc_joint_points_array_serialization_len(); // joint_points
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __object_points_size = object_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __object_points_size);
    for (size_t i = 0; i < __object_points_size; i++)
      write_ptr = object_points[i].serialize(write_ptr, seq);
    uint32_t __joint_points_size = joint_points.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_points_size);
    for (size_t i = 0; i < __joint_points_size; i++)
      write_ptr = joint_points[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __object_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __object_points_size);
    set_object_points_size(__object_points_size);
    for (size_t i = 0; i < __object_points_size; i++)
      read_ptr = object_points[i].deserialize(read_ptr);
    uint32_t __joint_points_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_points_size);
    set_joint_points_size(__joint_points_size);
    for (size_t i = 0; i < __joint_points_size; i++)
      read_ptr = joint_points[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<JointStateCalibrationPattern> JointStateCalibrationPatternPtr;
typedef boost::shared_ptr<JointStateCalibrationPattern const> JointStateCalibrationPatternConstPtr;


}

#endif
