# autogenerated by genmsg_py from CameraMeasurement.msg. Do not edit.
import roslib.message
import struct

import calibration_msgs.msg
import geometry_msgs.msg
import roslib.msg
import sensor_msgs.msg

class CameraMeasurement(roslib.message.Message):
  _md5sum = "090b0673159d7e94e15e007f839bb70d"
  _type = "calibration_msgs/CameraMeasurement"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header
string camera_id
ImagePoint[] image_points
sensor_msgs/CameraInfo cam_info

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
sensor_msgs/Image image
sensor_msgs/Image image_rect
calibration_msgs/CalibrationPattern features

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: calibration_msgs/ImagePoint
float32 x
float32 y

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace and accompanied by up to 5 image topics named:
# 
# image_raw, image, image_color, image_rect, and image_rect_color
#
# The meaning of the camera parameters are described in detail at
# http://pr.willowgarage.com/wiki/Camera_Calibration.

##########################
# Image acquisition info #
##########################

# Time of image acquisition, camera coordinate frame ID
Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of camera
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image

# Camera resolution in pixels
uint32 height
uint32 width

# Region of interest (subwindow of full camera resolution), if applicable
RegionOfInterest roi

##########################################
# Internal parameters                    #
# Used for warping to:                   #
#  1. An undistorted image (just D and K)#
#  2. A rectified image (D, K, R)        #
# Users should not normally need these   #
##########################################

# Distortion parameters: k1, k2, t1, t2, k3
# These model radial and tangential distortion of the camera.
float64[5]  D # 5x1 vector

# Intrinsic camera matrix for the raw (distorted) images
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]

float64[9]  K # 3x3 row-major matrix


# Rectification matrix (stereo cameras only)
# A homography which takes an image to the ideal stereo image plane
# so that epipolar lines in both stereo images are parallel.
float64[9]  R # 3x3 row-major matrix

######################################
# Projection/camera matrix           #
# This is a 3x4 projection matrix    #
#   for going from 3D to 2D coords   #
######################################

# Projection/camera matrix
# By convention, this matrix specifies the intrinsic (camera)
#   matrix of the processed (rectified) image.
# Upper 3x3 portion is the normal camera intrinsic matrix for
#   the rectified image
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy):
#              [fx  0 cx]
# P[1:3,1:3] = [ 0 fy cy]
#              [ 0  0  1]
# For the right camera of a stereo pair, P[4,1] is the position
#  of the right camera center in the left camera's frame, times
#  the focal length fx.
# 
# Given a 3D point q=[XYZ]^T in the left camera frame, the projection
#  of the point onto the image is given by [uvw]^T = Pq, with x=u/w and y=v/w.
#  This holds for both left and right images of a stereo pair.  
#  For monocular cameras and the left image of a stereo pair, P[4,1] is always 0.

float64[12] P # 3x4 row-major matrix

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: calibration_msgs/CalibrationPattern
Header header
geometry_msgs/Point32[] object_points
ImagePoint[] image_points
uint8 success

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"""
  __slots__ = ['header','camera_id','image_points','cam_info','verbose','image','image_rect','features']
  _slot_types = ['Header','string','calibration_msgs/ImagePoint[]','sensor_msgs/CameraInfo','bool','sensor_msgs/Image','sensor_msgs/Image','calibration_msgs/CalibrationPattern']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,camera_id,image_points,cam_info,verbose,image,image_rect,features
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(CameraMeasurement, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.camera_id is None:
        self.camera_id = ''
      if self.image_points is None:
        self.image_points = []
      if self.cam_info is None:
        self.cam_info = sensor_msgs.msg.CameraInfo()
      if self.verbose is None:
        self.verbose = False
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.image_rect is None:
        self.image_rect = sensor_msgs.msg.Image()
      if self.features is None:
        self.features = calibration_msgs.msg.CalibrationPattern()
    else:
      self.header = roslib.msg._Header.Header()
      self.camera_id = ''
      self.image_points = []
      self.cam_info = sensor_msgs.msg.CameraInfo()
      self.verbose = False
      self.image = sensor_msgs.msg.Image()
      self.image_rect = sensor_msgs.msg.Image()
      self.features = calibration_msgs.msg.CalibrationPattern()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.camera_id)
      #serialize self.camera_id
      buff.write(struct.pack('<I%ss'%length, length, self.camera_id))
      #serialize self.image_points
      length = len(self.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<3I', self.cam_info.header.seq, self.cam_info.header.stamp.secs, self.cam_info.header.stamp.nsecs))
      length = len(self.cam_info.header.frame_id)
      #serialize self.cam_info.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.cam_info.header.frame_id))
      buff.write(struct.pack('<6I', self.cam_info.height, self.cam_info.width, self.cam_info.roi.x_offset, self.cam_info.roi.y_offset, self.cam_info.roi.height, self.cam_info.roi.width))
      #serialize self.cam_info.D
      buff.write(struct.pack('<5d', *self.cam_info.D))
      #serialize self.cam_info.K
      buff.write(struct.pack('<9d', *self.cam_info.K))
      #serialize self.cam_info.R
      buff.write(struct.pack('<9d', *self.cam_info.R))
      #serialize self.cam_info.P
      buff.write(struct.pack('<12d', *self.cam_info.P))
      buff.write(struct.pack('<B3I', self.verbose, self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs))
      length = len(self.image.header.frame_id)
      #serialize self.image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image.header.frame_id))
      buff.write(struct.pack('<2I', self.image.height, self.image.width))
      length = len(self.image.encoding)
      #serialize self.image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image.encoding))
      buff.write(struct.pack('<BI', self.image.is_bigendian, self.image.step))
      length = len(self.image.data)
      #serialize self.image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image.data))
      buff.write(struct.pack('<3I', self.image_rect.header.seq, self.image_rect.header.stamp.secs, self.image_rect.header.stamp.nsecs))
      length = len(self.image_rect.header.frame_id)
      #serialize self.image_rect.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image_rect.header.frame_id))
      buff.write(struct.pack('<2I', self.image_rect.height, self.image_rect.width))
      length = len(self.image_rect.encoding)
      #serialize self.image_rect.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image_rect.encoding))
      buff.write(struct.pack('<BI', self.image_rect.is_bigendian, self.image_rect.step))
      length = len(self.image_rect.data)
      #serialize self.image_rect.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image_rect.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image_rect.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image_rect.data))
      buff.write(struct.pack('<3I', self.features.header.seq, self.features.header.stamp.secs, self.features.header.stamp.nsecs))
      length = len(self.features.header.frame_id)
      #serialize self.features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.features.header.frame_id))
      #serialize self.features.object_points
      length = len(self.features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.features.image_points
      length = len(self.features.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.features.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<B', self.features.success))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.cam_info is None:
        self.cam_info = sensor_msgs.msg.CameraInfo()
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.image_rect is None:
        self.image_rect = sensor_msgs.msg.Image()
      if self.features is None:
        self.features = calibration_msgs.msg.CalibrationPattern()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.camera_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.camera_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.image_points.append(val1)
      start = end
      end += 12
      (self.cam_info.header.seq, self.cam_info.header.stamp.secs, self.cam_info.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.cam_info.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.cam_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.cam_info.height, self.cam_info.width, self.cam_info.roi.x_offset, self.cam_info.roi.y_offset, self.cam_info.roi.height, self.cam_info.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.cam_info.D
      start = end
      end += 40
      self.cam_info.D = struct.unpack('<5d',str[start:end])
      #deserialize self.cam_info.K
      start = end
      end += 72
      self.cam_info.K = struct.unpack('<9d',str[start:end])
      #deserialize self.cam_info.R
      start = end
      end += 72
      self.cam_info.R = struct.unpack('<9d',str[start:end])
      #deserialize self.cam_info.P
      start = end
      end += 96
      self.cam_info.P = struct.unpack('<12d',str[start:end])
      start = end
      end += 13
      (self.verbose, self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      self.verbose = bool(self.verbose)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image.height, self.image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image.is_bigendian, self.image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image_rect.header.seq, self.image_rect.header.stamp.secs, self.image_rect.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image_rect.height, self.image_rect.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image_rect.is_bigendian, self.image_rect.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.features.header.seq, self.features.header.stamp.secs, self.features.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.features.object_points.append(val1)
      #deserialize self.features.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.features.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.features.image_points.append(val1)
      start = end
      end += 1
      (self.features.success,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.camera_id)
      #serialize self.camera_id
      buff.write(struct.pack('<I%ss'%length, length, self.camera_id))
      #serialize self.image_points
      length = len(self.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<3I', self.cam_info.header.seq, self.cam_info.header.stamp.secs, self.cam_info.header.stamp.nsecs))
      length = len(self.cam_info.header.frame_id)
      #serialize self.cam_info.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.cam_info.header.frame_id))
      buff.write(struct.pack('<6I', self.cam_info.height, self.cam_info.width, self.cam_info.roi.x_offset, self.cam_info.roi.y_offset, self.cam_info.roi.height, self.cam_info.roi.width))
      #serialize self.cam_info.D
      buff.write(self.cam_info.D.tostring())
      #serialize self.cam_info.K
      buff.write(self.cam_info.K.tostring())
      #serialize self.cam_info.R
      buff.write(self.cam_info.R.tostring())
      #serialize self.cam_info.P
      buff.write(self.cam_info.P.tostring())
      buff.write(struct.pack('<B3I', self.verbose, self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs))
      length = len(self.image.header.frame_id)
      #serialize self.image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image.header.frame_id))
      buff.write(struct.pack('<2I', self.image.height, self.image.width))
      length = len(self.image.encoding)
      #serialize self.image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image.encoding))
      buff.write(struct.pack('<BI', self.image.is_bigendian, self.image.step))
      length = len(self.image.data)
      #serialize self.image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image.data))
      buff.write(struct.pack('<3I', self.image_rect.header.seq, self.image_rect.header.stamp.secs, self.image_rect.header.stamp.nsecs))
      length = len(self.image_rect.header.frame_id)
      #serialize self.image_rect.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image_rect.header.frame_id))
      buff.write(struct.pack('<2I', self.image_rect.height, self.image_rect.width))
      length = len(self.image_rect.encoding)
      #serialize self.image_rect.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image_rect.encoding))
      buff.write(struct.pack('<BI', self.image_rect.is_bigendian, self.image_rect.step))
      length = len(self.image_rect.data)
      #serialize self.image_rect.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image_rect.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image_rect.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image_rect.data))
      buff.write(struct.pack('<3I', self.features.header.seq, self.features.header.stamp.secs, self.features.header.stamp.nsecs))
      length = len(self.features.header.frame_id)
      #serialize self.features.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.features.header.frame_id))
      #serialize self.features.object_points
      length = len(self.features.object_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.features.object_points:
        buff.write(struct.pack('<3f', val1.x, val1.y, val1.z))
      #serialize self.features.image_points
      length = len(self.features.image_points)
      buff.write(struct.pack('<I', length))
      for val1 in self.features.image_points:
        buff.write(struct.pack('<2f', val1.x, val1.y))
      buff.write(struct.pack('<B', self.features.success))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.cam_info is None:
        self.cam_info = sensor_msgs.msg.CameraInfo()
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.image_rect is None:
        self.image_rect = sensor_msgs.msg.Image()
      if self.features is None:
        self.features = calibration_msgs.msg.CalibrationPattern()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.camera_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.camera_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.image_points.append(val1)
      start = end
      end += 12
      (self.cam_info.header.seq, self.cam_info.header.stamp.secs, self.cam_info.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.cam_info.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.cam_info.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 24
      (self.cam_info.height, self.cam_info.width, self.cam_info.roi.x_offset, self.cam_info.roi.y_offset, self.cam_info.roi.height, self.cam_info.roi.width,) = struct.unpack('<6I',str[start:end])
      #deserialize self.cam_info.D
      start = end
      end += 40
      self.cam_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=5)
      #deserialize self.cam_info.K
      start = end
      end += 72
      self.cam_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.cam_info.R
      start = end
      end += 72
      self.cam_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      #deserialize self.cam_info.P
      start = end
      end += 96
      self.cam_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      start = end
      end += 13
      (self.verbose, self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs,) = struct.unpack('<B3I',str[start:end])
      self.verbose = bool(self.verbose)
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image.height, self.image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image.is_bigendian, self.image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image_rect.header.seq, self.image_rect.header.stamp.secs, self.image_rect.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image_rect.height, self.image_rect.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image_rect.is_bigendian, self.image_rect.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image_rect.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image_rect.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.features.header.seq, self.features.header.stamp.secs, self.features.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.features.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.features.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.features.object_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.features.object_points = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point32()
        start = end
        end += 12
        (val1.x, val1.y, val1.z,) = struct.unpack('<3f',str[start:end])
        self.features.object_points.append(val1)
      #deserialize self.features.image_points
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.features.image_points = []
      for i in xrange(0, length):
        val1 = calibration_msgs.msg.ImagePoint()
        start = end
        end += 8
        (val1.x, val1.y,) = struct.unpack('<2f',str[start:end])
        self.features.image_points.append(val1)
      start = end
      end += 1
      (self.features.success,) = struct.unpack('<B',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

