# autogenerated by genmsg_py from DenseLaserSnapshot.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime
import roslib.msg

class DenseLaserSnapshot(roslib.message.Message):
  _md5sum = "deb2810d3530db3484f886a81243195d"
  _type = "calibration_msgs/DenseLaserSnapshot"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','angle_min','angle_max','angle_increment','time_increment','range_min','range_max','readings_per_scan','num_scans','ranges','intensities','scan_start']
  _slot_types = ['Header','float32','float32','float32','float32','float32','float32','uint32','uint32','float32[]','float32[]','time[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,angle_min,angle_max,angle_increment,time_increment,range_min,range_max,readings_per_scan,num_scans,ranges,intensities,scan_start
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DenseLaserSnapshot, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.angle_min is None:
        self.angle_min = 0.
      if self.angle_max is None:
        self.angle_max = 0.
      if self.angle_increment is None:
        self.angle_increment = 0.
      if self.time_increment is None:
        self.time_increment = 0.
      if self.range_min is None:
        self.range_min = 0.
      if self.range_max is None:
        self.range_max = 0.
      if self.readings_per_scan is None:
        self.readings_per_scan = 0
      if self.num_scans is None:
        self.num_scans = 0
      if self.ranges is None:
        self.ranges = []
      if self.intensities is None:
        self.intensities = []
      if self.scan_start is None:
        self.scan_start = []
    else:
      self.header = roslib.msg._Header.Header()
      self.angle_min = 0.
      self.angle_max = 0.
      self.angle_increment = 0.
      self.time_increment = 0.
      self.range_min = 0.
      self.range_max = 0.
      self.readings_per_scan = 0
      self.num_scans = 0
      self.ranges = []
      self.intensities = []
      self.scan_start = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6f2I', self.angle_min, self.angle_max, self.angle_increment, self.time_increment, self.range_min, self.range_max, self.readings_per_scan, self.num_scans))
      #serialize self.ranges
      length = len(self.ranges)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.ranges))
      #serialize self.intensities
      length = len(self.intensities)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.intensities))
      #serialize self.scan_start
      length = len(self.scan_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.scan_start:
        buff.write(struct.pack('<2I', val1.secs, val1.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.angle_min, self.angle_max, self.angle_increment, self.time_increment, self.range_min, self.range_max, self.readings_per_scan, self.num_scans,) = struct.unpack('<6f2I',str[start:end])
      #deserialize self.ranges
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.ranges = struct.unpack(pattern, str[start:end])
      #deserialize self.intensities
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.intensities = struct.unpack(pattern, str[start:end])
      #deserialize self.scan_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.scan_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Time()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2I',str[start:end])
        self.scan_start.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<6f2I', self.angle_min, self.angle_max, self.angle_increment, self.time_increment, self.range_min, self.range_max, self.readings_per_scan, self.num_scans))
      #serialize self.ranges
      length = len(self.ranges)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(self.ranges.tostring())
      #serialize self.intensities
      length = len(self.intensities)
      buff.write(struct.pack('<I', length))
      pattern = '<%sf'%length
      buff.write(self.intensities.tostring())
      #serialize self.scan_start
      length = len(self.scan_start)
      buff.write(struct.pack('<I', length))
      for val1 in self.scan_start:
        buff.write(struct.pack('<2I', val1.secs, val1.nsecs))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 32
      (self.angle_min, self.angle_max, self.angle_increment, self.time_increment, self.range_min, self.range_max, self.readings_per_scan, self.num_scans,) = struct.unpack('<6f2I',str[start:end])
      #deserialize self.ranges
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      #deserialize self.intensities
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      #deserialize self.scan_start
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.scan_start = []
      for i in xrange(0, length):
        val1 = roslib.rostime.Time()
        start = end
        end += 8
        (val1.secs, val1.nsecs,) = struct.unpack('<2I',str[start:end])
        self.scan_start.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

