/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/robot_calibration/joint_states_settler/msg/ConfigGoal.msg.  Do not edit! */
#ifndef JOINT_STATES_SETTLER_CONFIGGOAL_H
#define JOINT_STATES_SETTLER_CONFIGGOAL_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace joint_states_settler
{

//! \htmlinclude ConfigGoal.msg.html

class ConfigGoal : public ros::Message
{
public:
  typedef boost::shared_ptr<ConfigGoal> Ptr;
  typedef boost::shared_ptr<ConfigGoal const> ConstPtr;

  typedef std::vector<std::string> _joint_names_type;
  typedef std::vector<double> _tolerances_type;
  typedef ros::Duration _max_step_type;
  typedef uint32_t _cache_size_type;

  std::vector<std::string> joint_names;
  std::vector<double> tolerances;
  ros::Duration max_step;
  uint32_t cache_size;

  ConfigGoal() : ros::Message(),
    cache_size(0)
  {
  }
  ConfigGoal(const ConfigGoal &copy) : ros::Message(),
    max_step(copy.max_step),
    cache_size(copy.cache_size)
  {
    (void)copy;
    joint_names = copy.joint_names;
    tolerances = copy.tolerances;
  }
  ConfigGoal &operator =(const ConfigGoal &copy)
  {
    if (this == &copy)
      return *this;
    joint_names.clear();
    tolerances.clear();
    joint_names = copy.joint_names;
    tolerances = copy.tolerances;
    max_step = copy.max_step;
    cache_size = copy.cache_size;
    return *this;
  }
  virtual ~ConfigGoal() 
  {
    joint_names.clear();
    tolerances.clear();
  }
  inline static std::string __s_getDataType() { return std::string("joint_states_settler/ConfigGoal"); }
  inline static std::string __s_getMD5Sum() { return std::string("863b25359077f9aa231257b3d1612b63"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "string[] joint_names   # Names of the joints we're waiting to settle\n"
    "float64[] tolerances   # Tolerance on each of the specified joints\n"
    "duration max_step      # The maximum timestep between two elements in an interval\n"
    "uint32 cache_size      # The size of our cache when searching for an interval\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_joint_names_size(uint32_t __ros_new_size)
  {
    this->joint_names.resize(__ros_new_size);
  }
  inline uint32_t get_joint_names_size() const { return joint_names.size(); }
  uint32_t calc_joint_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_names_size = joint_names.size();
    for (size_t i = 0; i < joint_names_size; i++)
      l += 4 + joint_names[i].length();
    return l;
  }
  inline void get_joint_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->joint_names;
  }
  inline void set_joint_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->joint_names = __ros_vec;
  }
  void set_tolerances_size(uint32_t __ros_new_size)
  {
    this->tolerances.resize(__ros_new_size);
  }
  inline uint32_t get_tolerances_size() const { return tolerances.size(); }
  inline void get_tolerances_vec (std::vector<double> &__ros_vec) const
  {
    __ros_vec = this->tolerances;
  }
  inline void set_tolerances_vec(const std::vector<double> &__ros_vec)
  {
    this->tolerances = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_joint_names_array_serialization_len(); // joint_names
    __l += 4 + (tolerances.size() ? tolerances.size() * 8 : 0); // tolerances
    __l += 8; // max_step
    __l += 4; // cache_size
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __joint_names_size = joint_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len = joint_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_names[i].c_str(), __ros_joint_names_i__len);
    }
    uint32_t __tolerances_size = tolerances.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __tolerances_size);
    memcpy(write_ptr, &tolerances[0], sizeof(double) * __tolerances_size);
    write_ptr += sizeof(double) * __tolerances_size;
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_step.sec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_step.nsec);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, cache_size);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __joint_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_names_size);
    set_joint_names_size(__joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_names_i__len);
    joint_names[i] = std::string((const char *)read_ptr, __ros_joint_names_i__len);
    read_ptr += __ros_joint_names_i__len;
    }
    uint32_t __tolerances_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __tolerances_size);
    set_tolerances_size(__tolerances_size);
    memcpy(&tolerances[0], read_ptr, sizeof(double) * __tolerances_size);
    read_ptr += sizeof(double) * __tolerances_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_step.sec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_step.nsec);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, cache_size);
    return read_ptr;
  }
};

typedef boost::shared_ptr<ConfigGoal> ConfigGoalPtr;
typedef boost::shared_ptr<ConfigGoal const> ConfigGoalConstPtr;


}

#endif
