# autogenerated by genmsg_py from ConfigGoal.msg. Do not edit.
import roslib.message
import struct

import roslib.rostime

class ConfigGoal(roslib.message.Message):
  _md5sum = "863b25359077f9aa231257b3d1612b63"
  _type = "joint_states_settler/ConfigGoal"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string[] joint_names   # Names of the joints we're waiting to settle
float64[] tolerances   # Tolerance on each of the specified joints
duration max_step      # The maximum timestep between two elements in an interval
uint32 cache_size      # The size of our cache when searching for an interval

"""
  __slots__ = ['joint_names','tolerances','max_step','cache_size']
  _slot_types = ['string[]','float64[]','duration','uint32']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_names,tolerances,max_step,cache_size
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ConfigGoal, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_names is None:
        self.joint_names = []
      if self.tolerances is None:
        self.tolerances = []
      if self.max_step is None:
        self.max_step = roslib.rostime.Duration()
      if self.cache_size is None:
        self.cache_size = 0
    else:
      self.joint_names = []
      self.tolerances = []
      self.max_step = roslib.rostime.Duration()
      self.cache_size = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.tolerances
      length = len(self.tolerances)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.tolerances))
      buff.write(struct.pack('<2iI', self.max_step.secs, self.max_step.nsecs, self.cache_size))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.max_step is None:
        self.max_step = roslib.rostime.Duration()
      end = 0
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.tolerances
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.tolerances = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.max_step.secs, self.max_step.nsecs, self.cache_size,) = struct.unpack('<2iI',str[start:end])
      self.max_step.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.tolerances
      length = len(self.tolerances)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.tolerances.tostring())
      buff.write(struct.pack('<2iI', self.max_step.secs, self.max_step.nsecs, self.cache_size))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.max_step is None:
        self.max_step = roslib.rostime.Duration()
      end = 0
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.tolerances
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.tolerances = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 12
      (self.max_step.secs, self.max_step.nsecs, self.cache_size,) = struct.unpack('<2iI',str[start:end])
      self.max_step.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

